Page MenuHomePhabricator

elementary: add internal Efl_Ui_Model_Homogeneous.
ClosedPublic

Authored by cedric on Jan 16 2019, 6:29 PM.

Details

Summary

This model enable View that require to compute the size of their item
to rely on its logic to have all items of the same size. It is the
equivalent of the Homogeneous behavior of Genlist, except that now this
behavior can be customized outside of the View logic itself.

Depends on D7658

Diff Detail

Repository
rEFL core/efl
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
cedric created this revision.Jan 16 2019, 6:29 PM
cedric requested review of this revision.Jan 16 2019, 6:29 PM
segfaultxavi requested changes to this revision.Jan 17 2019, 3:20 AM
segfaultxavi added inline comments.
src/lib/elementary/efl_ui_model_homogeneous.eo
6
This model provides the properties $Item.Width and $Item.Height which have the same value for all siblings of this object. The first sibling that defines $Self.Width and $Self.Height set them for all other siblings and also set $Item.Width and $Item.Height for the parent (See @Efl.Ui.Model_Size).
Subsequent attempts to set $Self.Width or $Self.Height will fail with a Read Only error code.

Please check that I got it right... there's a bit of confusion on whether the Model_Homogeneous is the parent or the children.

This revision now requires changes to proceed.Jan 17 2019, 3:20 AM
cedric updated this revision to Diff 18579.Jan 17 2019, 4:43 PM
cedric edited the summary of this revision. (Show Details)

Rebase and improve documentation.

segfaultxavi added inline comments.Jan 18 2019, 3:40 AM
src/lib/elementary/efl_ui_model_homogeneous.eo
6

Please do not mix $ and quotes. Use only $.

14

*nodes

cedric updated this revision to Diff 18636.Jan 18 2019, 12:42 PM

Rebase and fix syntax.

cedric updated this revision to Diff 18770.Jan 23 2019, 2:39 PM

Rebase and improve documentation.

cedric updated this revision to Diff 18817.Jan 24 2019, 3:38 PM

Rebase and fix doc.

cedric updated this revision to Diff 18900.Jan 25 2019, 2:58 PM

Rebase and rename.

segfaultxavi resigned from this revision.Jan 28 2019, 5:48 AM

Docs look good to me. Will handle any outstanding issues in a separate commit.

Resigning as reviewer so somebody else can review the rest of the patch.

SanghyeonLee requested changes to this revision.Jan 29 2019, 2:03 AM

I think code looks good and build/check works well.
only the meson build may not proper to fix in this commit.

src/lib/elementary/meson.build
111–112

should it fixed here?

345

should it fixed here?

This revision now requires changes to proceed.Jan 29 2019, 2:03 AM
cedric added inline comments.Jan 29 2019, 1:21 PM
src/lib/elementary/meson.build
345

It was defined in two place before which was confusing and could lead to bugs. I kept the one just next to where it was going to be used.

This revision was not accepted when it landed; it landed in state Needs Review.Jan 30 2019, 12:10 PM
This revision was automatically updated to reflect the committed changes.